"jacPipe" <-
function(pobj, fc, H, K, xleak=NA, pleak=0)
{
  n <- pobj$n
  if (length(fc)!=n)
    stop("Wrong length for friction coefficient")

  if (is.na(K) || K==Inf) K <- -1 # valve shut 

  if (is.na(pleak) || pleak<=0 || pleak>=1)
    pleak <- xleak <- 0
  else
    if (is.na(xleak) || xleak<=0 || xleak>=pobj$L)
      stop("Inappropriate value for \"xleak\"")

  thIn <- c(pobj$head, pobj$flow) # length n+1
  jac <- double((n+1)^2)
  v <- (n+1)/2
  cscale <- rep(c(mean(abs(pobj$head)), mean(abs(pobj$flow))), c(v, v))

  jac <- .C("jacPipe",
    jac = jac,
    as.double(cscale),
    as.double(thIn),
    as.double(fc),
    as.integer(n),
    as.integer(pobj$even),
    as.double(pobj$L),
    as.double(pobj$D),
    as.double(pobj$A),
    as.double(pobj$G),
    as.double(H),
    as.double(K),
    as.double(xleak),
    as.double(pleak)
  )$jac

  dim(jac) <- rep(n+1, 2)
  jac
}

"linearPipe" <-
function(pobj, ...)
{
  np <- stepPipe(pobj, ...)
  G <- jacPipe(pobj, ...)
  g <- c(np$head, np$flow) - G %*% c(pobj$head, pobj$flow)
  list(g=g, G=G)
}
