"stepPipe" <-
function(pobj, fc, H, K, xleak=NA, pleak=0)
{
  n <- pobj$n
  if (length(fc)!=n)
    stop("Wrong length for friction coefficient")

  if (is.na(K) || K==Inf) K <- -1 # valve shut 

  if (is.na(pleak) || pleak<=0 || pleak>=1)
    pleak <- xleak <- 0
  else
    if (is.na(xleak) || xleak<=0 || xleak>=pobj$L)
      stop("Inappropriate value for \"xleak\"")

  thIn <- c(pobj$head, pobj$flow) # length n+1
  thOut <- thIn # also length n+1

  thOut <- .C("onestep",
    thOut = as.double(thOut),
    as.double(thIn),
    as.double(fc),
    as.integer(n),
    as.integer(pobj$even),
    as.double(pobj$L),
    as.double(pobj$D),
    as.double(pobj$A),
    as.double(pobj$G),
    as.double(H),
    as.double(K),
    as.double(xleak),
    as.double(pleak)
  )$thOut

  v <- (n+1)/2
  pobj$head <- thOut[1:v]
  pobj$flow <- thOut[-(1:v)]
  pobj$even <- !pobj$even

  pobj
}
